/*
	$Id: keyboard.h,v 1.4 2000/11/21 15:06:00 sphair Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

//! component="Input"

#ifndef header_keyboard
#define header_keyboard

#include "inputdevice.h"

class CL_Keyboard : public CL_InputDevice
//: Keyboard interface in ClanLib.
// This is the keyboard input device interface. It contains all the extra
// functions needed by the keyboard, which didn't fit into the general
// CL_InputDevice abstraction.
{
public:
	virtual ~CL_Keyboard() { return; }

	static bool get_keycode(int button_no);
	//: Returns true if the specified button is down on the keyboard.
	//: <br>
	//: This static function is an easier way of writing 
	//: CL_Input::keyboards[0]->get_button->is_pressed();
	//!param: button_no - Button number checked for being pressed.
	//!retval: True if the key is pressed.
};

#endif

