/*
	$Id: netobject.h,v 1.10 2000/10/18 21:13:13 japj Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_netobject
#define header_netobject

#include <string>
#include "../../signals.h"

class CL_NetObject
{
public:
	CL_NetObject(const CL_NetObject &copy);
	CL_NetObject(class CL_NetObjectChannel *obj_channel);
	CL_NetObject(int obj_id, class CL_NetObjectChannel *obj_channel);
	virtual ~CL_NetObject();

	thSlot connect(int msg_type, const thSlot_1<void, class CL_InputSource &> &slot);
	thSlot connect(int talkback_type, const thSlot_2<void, const class CL_NetComputer *, class CL_InputSource &> &slot);
	void send(int msg_type, const std::string &message);
	void talkback(int talkback_type, const std::string &message);

	int get_obj_id() const;

public:
	class CL_NetObject_Generic *impl;
};

#endif

