/*
	$Id: netobject_channel.h,v 1.6 2000/10/25 11:53:12 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------
*/

#ifndef header_netobject_channel
#define header_netobject_channel

#include <string>
#include "../../signals.h"

class CL_NetObjectChannel
{
public:
	CL_NetObjectChannel(const CL_NetObjectChannel &copy);
	CL_NetObjectChannel(class CL_NetGame *netgame, int channel);
	virtual ~CL_NetObjectChannel();

	thSignal_v3<const class CL_NetObject &, int, const std::string &> &sig_create_object();

	void begin_sync(const class CL_NetGroup *group = NULL);
	void end_sync(const class CL_NetGroup *group = NULL);
	bool wait_sync(int timeout = -1);

public:
	class CL_NetObjectChannel_Generic *impl;
};

#endif

