/*
	Dodge This, ClanLib example Game,
	Copyright 1999-2000 by the Dodge This Development Team.
	
	This game is licensed under the GNU PUBLIC LICENSE (GPL), version 2.
*/

#ifndef header_object3d
#define header_object3d

#include "../../Core/Math/cl_vector.h"
#include "object3d_data.h"
#include "object3d_provider.h"
#include "../clipinfo.h"
#include "../viewpoint.h"
#include "../../Core/IOData/inputsource.h"
/*
class CL_ResourceManager;
class CL_InputSource;
class Viewpoint;
class ClipInfo;
*/

class CL_Object3D
//: The abstract interface to a "physical" 3D object in the game.
// <p>This class can be compared to a CL_Surface, CL_Texture, CL_Font,
// etc etc, but just for 3D objects instead.</p>
// <p>To construct a 3D object, either use the static load() function in
// in this class, or create an inheriated variant of this class. Eg. the
// 3D Studio format loader.</p>
{
public:
	static CL_Object3D *load(
		const char *res_id,
		CL_ResourceManager *manager);
	// Loads a 3D object from a resource.
	//!param: res_id - The resource ID of the resource.
	//!param: manager - The resource manager that has the resource.

	
	static CL_Object3D *load(
		CL_InputSource *input,
		CL_ResourceManager *manager);
	// Loads the object from a datafile input source.


	


	static CL_Object3D *create(
		CL_Object3DProvider *provider,
		CL_Vector init_scale,
		CL_Vector init_pos,
		CL_Vector init_dir,
		CL_Vector init_up,
		bool delete_provider=false);
	//: This function creates a Object3D instance being blitted by a caching blitter.
	//!param: provider - 3D object source.
	//!param: delete_provider - If true, the surface will delete the provider when deleted itself.
	//!retval: The surface created.
/*
	virtual CL_SurfaceProvider *get_provider() const =0;
//: Returns the surface provider used by this surface.
//!retval: Surface provider used by this surface.


*/


	CL_Object3D();
	~CL_Object3D();
	
	// Show the object using OpenGL commands.
	void show(const CL_Viewpoint &position, CL_ClipInfo &clipinfo, float scale=1.0);
	

	//wiew/show info
	CL_Vector init_scale;
	CL_Vector init_pos;
	CL_Vector init_dir;
	CL_Vector init_up;

//	std::vector<Object3D_Data_TriangularMesh> &GetTriMesh() {return data->meshlist;}
	/*
	std::vector<Vertex> &GetObjectVertices() { return m_object->m_vertices;}
	std::vector<Face> &GetObjectFaces() { return m_object->m_faces;}
	*/
	//object data
	Object3D_Data data;




};

#endif
















