/*
	Dodge This, ClanLib example Game,
	Copyright 1999-2000 by the Dodge This Development Team.
	
	This game is licensed under the GNU PUBLIC LICENSE (GPL), version 2.
*/

#ifndef header_object3d_data
#define header_object3d_data

#include <vector>
#include "../../Core/Math/cl_vector.h"


//////////////////////////////////////////////////////////



class Object3D_Data_Color
{
public:
	float r,g,b;
};

class Object3D_Data_Map
{
public:
//	Object3D_Map(){};
//	Map_3DS(float u, float v);
	float u;
	float v;
};

class Object3D_Data_Vertex
{
public:
	//Vertex_3DS();
	//Vertex_3DS(float x, float y, float z);

	float x;
	float y;
	float z;

	Object3D_Data_Map map;
};

class Object3D_Data_Face
{
public:
//	Object3D_Data_Face(unsigned long v1, unsigned long v2, unsigned long v3, unsigned short flags, int iMat, int iTex);
		
	unsigned long	VertexIndex[3];   // indexes of the vertexes used by the face
	unsigned short  flags;
    int				MaterialIndex;
    int				TextureIndex;
};

class Object3D_Data_Texture
{
public:
	//Object3D_Texture(){};
	//Texture_3DS(char *filename, int MaterialIndex);
	std::string  filename;
	int   MaterialIndex;
};

class Object3D_Data_Material
{
public:
	std::string name; 
	Object3D_Data_Color ambient;
    Object3D_Data_Color diffuse;
    Object3D_Data_Color specular;
    Object3D_Data_Color shininess;
    Object3D_Data_Color emission;
};


class Object3D_Data_Object
{
public:
	std::string name;				// object name, zero terminated
	bool hidden;
	bool dosent_cast;
	bool matte;
	bool external_process_on;
	bool object_doesnt_receive_shadows;
};


class Object3D_Data_TriangularMesh : public Object3D_Data_Object
{
public:
	
	int num_faces;					// number of faces in facelist
    int num_vertices;				// number of vertices in vertlist
						
	std::vector<Object3D_Data_Face>		facelist; 
	std::vector<Object3D_Data_Vertex>	vertlist;

		
	float matrix[4][3];				// 3*3 rotation matrix, 3*1 translation matrix

	Object3D_Data_Color color;				// Object color in 3D Editor.
};


class Object3D_Data_Light : public Object3D_Data_Object
{
public:

	float pos_x;
    float pos_y;
	float pos_z;

	//spot light
	float target_x;
	float target_y;
	float target_z;

	float hot_spot;
	float falloff;

	float roll;// (degree)

	std::string map;

	bool light_is_spotlight;
	bool spot_is_rect;
};
 
class Object3D_Data
//: This class holds the Object3d data. 
{
public:

	
//	void operator=(Object3D_Data &obj_data); //Make this Object3D_Data equal with another
//	void operator=(Object3D_Data &obj_data); //Make this Object3D_Data equal with another
//	void operator=(Object3D_Data *obj_data); //Make this Object3D_Data equal with another

	/*
	//wiew/show info
	CL_Vector init_scale;
	CL_Vector init_pos;
	CL_Vector init_dir;
	CL_Vector init_up;
*/
	//object info
	int num_meshes;
	int num_lights;
	int num_mats;

	std::vector<Object3D_Data_TriangularMesh>	meshlist;
	std::vector<Object3D_Data_Light>			lightlist;
	std::vector<Object3D_Data_Material>			matlist;
};

#endif
















