/*
	Dodge This, ClanLib example Game,
	Copyright 1999-2000 by the Dodge This Development Team.
	
	This game is licensed under the GNU PUBLIC LICENSE (GPL), version 2.
*/

#ifndef header_object3d_resource
#define header_object3d_resource

#include "../../Core/Resources/resource.h"
#include "../../Core/Resources/resourcetype.h"
#include "../../Core/Math/cl_vector.h"

#include "object3d.h"

using namespace std;



class CL_Object3DResourceType : public CL_ResourceType
{
public:
	CL_Object3DResourceType() : CL_ResourceType("object3d") { return; }

	virtual CL_Resource *create_from_location(
		string name,
		string location,
		CL_ResourceOptions *options,
		CL_ResourceManager *parent);

	virtual CL_Resource *create_from_serialization(
		string name,
		CL_ResourceManager *parent);
};

class CL_Object3DResource : public CL_Resource
{
public:
	CL_Object3DResource(
		string name,
		string location,
		CL_ResourceOptions *options,
		CL_ResourceManager *parent,
		bool from_datafile);
	
	virtual ~CL_Object3DResource();

	virtual void serialize_save(CL_OutputSource *output);
	virtual void load();
	virtual void unload();
	virtual int get_load_count() { return load_count; }

	virtual CL_Object3D *create();

private:
	CL_Vector get_float(CL_ResourceOptions *options, const char *name);

	CL_Object3D *object3d;
	string source, prefix, res_id;
	bool from_datafile;
	CL_ResourceManager *parent;
	CL_ResourceOptions *options;
	int load_count;
};

#endif

