/*
	Dodge This, ClanLib example Game,
	Copyright 1999-2000 by the Dodge This Development Team.
	
	This game is licensed under the GNU PUBLIC LICENSE (GPL), version 2.
*/

#ifndef header_camera
#define header_camera

class CL_Viewpoint;
class CL_Camera
//: This is DodgeThis camera class.
// <p>Camera maintains the projection and view matrix in DodgeThis.</p>
{
public:
	CL_Camera();
	// Constructs an uninitialized camera.

	CL_Camera(
		float nearZ,
		float farZ,
		float fov);
	// Constructs a camera.
	//!param: pos - The position that the camera stands in.
	//!param: dir - The direction that the camera looks in.
	//!param: up - The up direction of the camera.
	//!param: nearZ - Near clipping plane.
	//!param: farZ - Far clipping plane.
	//!param: fov - Field of view.

	void set_viewport(const CL_Viewpoint &viewpoint, float distance) const;
	// Set view matrix to look from the camera's point of view.

	float fov, nearZ, farZ;
};

#endif

