/*
	Dodge This, ClanLib example Game,
	Copyright 1999-2000 by the Dodge This Development Team.
	
	This game is licensed under the GNU PUBLIC LICENSE (GPL), version 2.
*/

#ifndef header_clipinfo
#define header_clipinfo

#include "camera.h"
#include "viewpoint.h"

class CL_ClipInfo
//: Clipping information class.
// <p>This class is used by all drawable objects to do intercommunication
// between what's viewable and what isn't.</p>
// <p>At the moment it only contains the camera (eye type) and camera's
// viewpoint, but if more advanced clipping techniques should be needed,
// then this is where the toplevel support should be added.</p>
{
public:
	CL_Camera camera;
	// The camera/eye type.

	CL_Viewpoint viewpoint;
	// The camera/eye's viewpoint center.

	float distance;
	// distance from center to real pos
};

#endif

