#ifndef header_combobox
#define header_combobox

#include "component.h"
#include "button.h"
#include "component_options.h"
#include "stylemanager.h"

class CL_Combobox : public CL_Component
{
public:
	static CL_Combobox *create(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style);

	static CL_Combobox *create(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_Combobox(const CL_ComponentOptions &options, CL_Component *parent);
	CL_Combobox(CL_Component *parent);
	virtual ~CL_Combobox() { return; }

	std::list<std::string> &options() { return m_options; }

	const std::string &cur_selected();
	int cur_selected() const { return cur_selection; }
	void change_selection(int new_selection);

	thSignal_v1<int> sig_changed;
	//: This signal is emitted whenever the listbox changes selected option
	//!param: int selection - The newly selected listbox option

	thSignal_v0 sig_activated;
	thSignal_v0 sig_deactivated;

	std::list<std::string> m_options;

	void set_select_button(CL_Button *select_button);
	bool activated;
	bool skip_next_activation;
	int cur_selection;

private:
	CL_Button *select_button;
	void select_clicked();
	thSlot slot_clicked, slot_pressed;

	thSlotContainer slots;
};  


#endif
