/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_component_type
#define header_component_type

#include <set>
#include <string>

class CL_ComponentType
{
public:
	CL_ComponentType(bool _is_container) : container(_is_container) {;}
	virtual ~CL_ComponentType() {;}

	virtual bool is_container()
	{
		return container;
	}
	virtual bool has_option(const std::string &option_name)
	{
		return options.find(option_name) != options.end();
	}

protected:
	bool container;
	std::set<std::string> options;
};

#endif
