/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef dialog_header
#define dialog_header

#include "component.h"
#include "component_options.h"
#include "stylemanager.h"
#include "button.h"
#include "label.h"

class CL_Dialog: public CL_Component
{
public:
	static CL_Dialog *create(
		const CL_ComponentOptions &options,	
		CL_StyleManager *style);

	CL_Dialog(const CL_ComponentOptions &options,CL_StyleManager *style);
	CL_Dialog(CL_Component *parent) : CL_Component(parent) { ; }
	virtual ~CL_Dialog() { return; }

	void set_text(CL_String _text)
	{
		text->set_text(_text);
	}

	void set_title(CL_String _title)
	{
		title->set_text(_title);
	}

	thSignal_v0 sig_ok;	
	thSignal_v0 sig_cancel;	

protected:
	void on_ok();

	thSlotContainer slots;

	CL_Button *ok;
	CL_Label *text;
	CL_Label *title;
};

#endif

