//! component="GUI"
/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_gui_manager
#define header_gui_manager

#include <stddef.h>

class CL_Component;
class CL_ComponentManager;

class CL_GUIManager
//: Manages the GUI, I think
{
public:
	// classic ClanLib 0.4.x initialization:
	static CL_GUIManager *create();
	static CL_GUIManager *create(CL_ComponentManager *component_manager);

	// constructors:
	CL_GUIManager();
	CL_GUIManager(CL_GUIManager *parent);
	CL_GUIManager(CL_ComponentManager *component_manager);
	virtual ~CL_GUIManager();

	// attributes:
	CL_Component *get_focus_component();
	bool has_focus(const CL_Component *component);

	// operations:
	void add_child(CL_Component *component);
	//: Adds a component
	void remove_child(CL_Component *component);
	void add_components(CL_ComponentManager *component_manager);

	void set_focus(CL_Component *component, CL_Component *child_component = NULL);

	void reset();
	//:Returns the GUI to the initial state

	void show();
	//:Draws the GUI once

	void run();
	//: Redraws the GUI continuosly
	void quit();

	void enable_input();
	//:Tells the GUI to start accepting input
	void disable_input();
	//:Tells the GUI to stop accepting input

	void capture_mouse(CL_Component *component);
	void release_mouse();

	// implementation:
private:
	CL_GUIManager(const CL_GUIManager &copy) { return; } // disallow copy construction
	class CL_GUIManager_Generic *impl;
};

#endif

