//! component="GUI"
/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_inputbox
#define header_inputbox

#include "component.h"
#include "component_options.h"
#include "stylemanager.h"

class CL_Inputbox : public CL_Component
//:Accepts keyboard input
{
public:
	static CL_Inputbox *create(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style);

	static CL_Inputbox *create(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_Inputbox(const CL_ComponentOptions &options, CL_Component *parent);
	CL_Inputbox(CL_Component *parent) : CL_Component(parent) { ; }
	virtual ~CL_Inputbox() { return; }

	thSignal_v1<const std::string &> sig_changed;

	const std::string &value() const { return text; }
	void set_value(const std::string &new_value) { text = new_value; }
	std::string get_value(){return text;}

protected:
	virtual void on_key_down(CL_Component *comp, CL_InputDevice *device, CL_Key key);
	virtual void on_key_up(CL_Component *comp, CL_InputDevice *device, CL_Key key);
	virtual void on_mouse_move(CL_Component *comp, CL_InputDevice *device, int x, int y);

	void update_text(CL_Key key);
	virtual int get_mouse_position(int x, int y)=0;
	virtual void check_keyboard_reposition(CL_Key key);

	std::string text;
	int caret_position;

	void delete_selected();
	bool selecting;
	bool mouse_selecting;
	int select_start;

	bool ctrl_down;
	bool shift_down;

	thSlotContainer slots;
};

#endif

