/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_label
#define header_label

#include "../Core/Math/point.h"

#include "component.h"
#include "component_options.h"
#include "stylemanager.h"

class CL_Label : public CL_Component
{
public:
	static CL_Label *create(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style);

	static CL_Label *create(
		const CL_Point &pos,
		const std::string &text,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_Label(const CL_ComponentOptions &options, CL_Component *parent);
	CL_Label(CL_Component *parent) : CL_Component(parent) { ; }

	virtual ~CL_Label() { return; }

	void set_text(const std::string &text) { this->text = text; }
	const std::string &get_text() { return text; }

protected:
	std::string text;
};  

#endif

