/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_popupmenu
#define header_popupmenu

#include "component_options.h"
#include "menudata.h"
#include "menuitem.h"

class CL_Component;
class CL_StyleManager;

class CL_PopupMenu : public CL_MenuData
{
public:
	static CL_PopupMenu *create(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style);

	static CL_PopupMenu *create(
		const class CL_Point &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);

	CL_PopupMenu(const CL_ComponentOptions &options, CL_Component *parent);

	virtual ~CL_PopupMenu() { return; }

	virtual void close();

//	void create(CL_Component *parent, int x, int y);

	thSignal_v0 sig_cancelled;
	thSignal_v1<int /*itemid*/> sig_clicked;

private:
	virtual void on_item_activated(CL_MenuItem *item, CL_PopupMenu *child);

	thSlotContainer slots;
	
	void on_got_focus();
	void close_children();

private:
	bool checkable;
};  

#endif

