/*
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_window
#define header_window

#include "component.h"
#include "component_options.h"

class CL_Component;
class CL_StyleManager;

class CL_Window : public CL_Component
{
public:
//!Construction:
	static CL_Window *create(
		const CL_ComponentOptions &options,
		CL_Component *parent,
		CL_StyleManager *style);
	// Creates a window using the parameters passed in the 'options' structure.

	static CL_Window *create(
		const CL_Rect &pos,
		CL_Component *parent,
		CL_StyleManager *style = NULL);
	// Creates a window located at the given position.

	CL_Window(const CL_ComponentOptions &options, CL_Component *parent);
	// Creates a window using the parameters passed in the 'options' structure.

//	CL_Window(const CL_Rect &pos, CL_Component *parent, CL_StyleManager *style);
//	// Creates a window located at the given position.
	
	virtual ~CL_Window();

//!Attributes:
	CL_Component *get_client_area();
	// Returns the client area of the window.

//!Operations:

//!Signals:

private:
	CL_Component *client_area;
};  

#endif

