//! component="Slots and Signals"

#ifndef _TheHerd_SNS__connection_H_
#define _TheHerd_SNS__connection_H_

#include "std.h"
#include "slot.h"

thBEGIN

class th_Slot;

class th_Connection {
//: Slot Connection interface
  protected:
    th_Slot * mySlot;
    th_Connection(const thSlot & _rhs);

  public:
    th_Connection(const th_Connection & _rhs);
    //Copy Constructor
    th_Connection & operator = (const th_Connection & _rhs);
    //Standard = operator
		~th_Connection();
    //Destructor

    int  nSlRefs() const;
    int  nSiRefs() const;
    bool isValid() const;
    //Returns whether it's valid or not

/* MBN: this function breaks the reference counting concepts of these classes!!!
    void invalidate();
    //Invalidates self?
*/

    bool operator == (const thSlot & _slot) const {
			return mySlot == _slot.mySlot;
		}
    //Boolean equivalence operator
 };

thEND

#endif

