#include "std.h"

thBEGIN

/** This stack is specialy designed for use within signals
 * The purpose for this kind of stack is to provide a
 * means to detect if our class has expired before
 * our method has finished.
 */
class thOVStack {
	protected:
		struct sData {
			unsigned int items;
			unsigned int maximum;
//			bool * item[0];
		};
		sData * myData;

	public:
		thOVStack();
		thOVStack(const thOVStack & _rhs);
		~thOVStack();

		void push(bool & _item);
		void pop(const bool & _item); // used for debuging, should still work just as a stack

		void clear(bool _value = false);

	private:
		// not to be implemented
		thOVStack & operator = (const thOVStack & _rhs) const;
};

/** Helper class for use within brstack's
 * This class works much along the lines of auto_ptr's and such,
 * but instead of holding memory, it adds/removes itself from 
 * a given stack.
 */
class thOVCheck {
	protected:
		bool amValid;
		thOVStack & theStack;

	public:
		thOVCheck(thOVStack & _brstack);
	 ~thOVCheck();

		bool valid() const;

		operator bool () const {
			return valid();
		}
	private:
		// not to be implemented
		thOVCheck(const thOVCheck &);
		// not to be implemented
		thOVCheck & operator = (const thOVCheck & _rhs) const;
};

thEND

