//! component="Slots and Signals"


class thSignal_v0 {
//: Signal Template, 0 arguments
	public:
		typedef bool tRETURN;

	protected:
		typedef thNS(std::)list< th_Connection_0<bool> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()() {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())()) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}

			return true;
		}

		thSlot_0<bool> connect(const thSlot_0<void> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());*/
		}
	};

template <class xPARAMATER1>
class thSignal_v1 {
//: Signal Template, 1 argument
//FIXME: signal_sc.m4.h:72
	public:
		typedef bool tRETURN;
    typedef xPARAMATER1 tPARAMATER1;

	protected:
		typedef thNS(std::)list< th_Connection_1<bool, xPARAMATER1> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()(tPARAMATER1 _paramater1) {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())(_paramater1)) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
			return true;
		}

		thSlot_1<bool, xPARAMATER1> connect(const thSlot_1<void, xPARAMATER1> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());*/
		}
	};

template <class xPARAMATER1, class xPARAMATER2>
class thSignal_v2 {
//: Signal template, 2 arguments
//FIXME signal_sc.m4.h:140
	public:
		typedef bool tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;

	protected:
		typedef thNS(std::)list< th_Connection_2<bool, xPARAMATER1, xPARAMATER2> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2) {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())(_paramater1, _paramater2)) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
			return true;
		}

		thSlot_2<bool, xPARAMATER1, xPARAMATER2> connect(const thSlot_2<void, xPARAMATER1, xPARAMATER2> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3>
class thSignal_v3 {
//: Signal template, 3 arguments
	public:
		typedef bool tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;

	protected:
		typedef thNS(std::)list< th_Connection_3<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3) {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())(_paramater1, _paramater2, _paramater3)) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
			return true;
		}

		thSlot_3<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3> connect(const thSlot_3<void, xPARAMATER1, xPARAMATER2, xPARAMATER3> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3, class xPARAMATER4>
class thSignal_v4 {
//: Signal template, 4 arguments
	public:
		typedef bool tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;
    typedef xPARAMATER4 tPARAMATER4;

	protected:
		typedef thNS(std::)list< th_Connection_4<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3, tPARAMATER4 _paramater4) {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())(_paramater1, _paramater2, _paramater3, _paramater4)) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
			return true;
		}

		thSlot_4<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4> connect(const thSlot_4<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3, class xPARAMATER4, class xPARAMATER5>
class thSignal_v5 {
//: Signal template, 5 arguments
	public:
		typedef bool tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;
    typedef xPARAMATER4 tPARAMATER4;
    typedef xPARAMATER5 tPARAMATER5;

	protected:
		typedef thNS(std::)list< th_Connection_5<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3, tPARAMATER4 _paramater4, tPARAMATER5 _paramater5) {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())(_paramater1, _paramater2, _paramater3, _paramater4, _paramater5)) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
			return true;
		}

		thSlot_5<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5> connect(const thSlot_5<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3, class xPARAMATER4, class xPARAMATER5, class xPARAMATER6>
class thSignal_v6 {
//: Signal template, 6 arguments
	public:
		typedef bool tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;
    typedef xPARAMATER4 tPARAMATER4;
    typedef xPARAMATER5 tPARAMATER5;
    typedef xPARAMATER6 tPARAMATER6;

	protected:
		typedef thNS(std::)list< th_Connection_6<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5, xPARAMATER6> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		bool operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3, tPARAMATER4 _paramater4, tPARAMATER5 _paramater5, tPARAMATER6 _paramater6) {
			tconnections::iterator i   = myConnections.begin();
			tconnections::iterator end = --myConnections.end();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						if (!(*(*i).getSlot())(_paramater1, _paramater2, _paramater3, _paramater4, _paramater5, _paramater6)) 
							return false;
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
			return true;
		}

		thSlot_6<bool, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5, xPARAMATER6> connect(const thSlot_6<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5, xPARAMATER6> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};


