


class thSignal_v0 {
	public:
		typedef void tRETURN;

	protected:
		typedef thNS(std::)list< th_Connection_0<void> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()() {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())();
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_0<void> connect(const thSlot_0<void> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1>
class thSignal_v1 {
	public:
		typedef void tRETURN;
    typedef xPARAMATER1 tPARAMATER1;

	protected:
		typedef thNS(std::)list< th_Connection_1<void, xPARAMATER1> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()(tPARAMATER1 _paramater1) {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())(_paramater1);
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_1<void, xPARAMATER1> connect(const thSlot_1<void, xPARAMATER1> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2>
class thSignal_v2 {
	public:
		typedef void tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;

	protected:
		typedef thNS(std::)list< th_Connection_2<void, xPARAMATER1, xPARAMATER2> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2) {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())(_paramater1, _paramater2);
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_2<void, xPARAMATER1, xPARAMATER2> connect(const thSlot_2<void, xPARAMATER1, xPARAMATER2> &  _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3>
class thSignal_v3 {
	public:
		typedef void tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;

	protected:
		typedef thNS(std::)list< th_Connection_3<void, xPARAMATER1, xPARAMATER2, xPARAMATER3> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3) {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())(_paramater1, _paramater2, _paramater3);
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_3<void, xPARAMATER1, xPARAMATER2, xPARAMATER3> connect(const thSlot_3<void, xPARAMATER1, xPARAMATER2, xPARAMATER3>& _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3, class xPARAMATER4>
class thSignal_v4 {
	public:
		typedef void tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;
    typedef xPARAMATER4 tPARAMATER4;

	protected:
		typedef thNS(std::)list< th_Connection_4<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3, tPARAMATER4 _paramater4) {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())(_paramater1, _paramater2, _paramater3, _paramater4);
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_4<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4> connect(const thSlot_4<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3, class xPARAMATER4, class xPARAMATER5>
class thSignal_v5 {
	public:
		typedef void tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;
    typedef xPARAMATER4 tPARAMATER4;
    typedef xPARAMATER5 tPARAMATER5;

	protected:
		typedef thNS(std::)list< th_Connection_5<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3, tPARAMATER4 _paramater4, tPARAMATER5 _paramater5) {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())(_paramater1, _paramater2, _paramater3, _paramater4, _paramater5);
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_5<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5> connect(const thSlot_5<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};

template <class xPARAMATER1, class xPARAMATER2, class xPARAMATER3, class xPARAMATER4, class xPARAMATER5, class xPARAMATER6>
class thSignal_v6 {
	public:
		typedef void tRETURN;
    typedef xPARAMATER1 tPARAMATER1;
    typedef xPARAMATER2 tPARAMATER2;
    typedef xPARAMATER3 tPARAMATER3;
    typedef xPARAMATER4 tPARAMATER4;
    typedef xPARAMATER5 tPARAMATER5;
    typedef xPARAMATER6 tPARAMATER6;

	protected:
		typedef thNS(std::)list< th_Connection_6<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5, xPARAMATER6> > tconnections;

		thOVStack    myOVStack;
		tconnections myConnections;

	public:
		void operator ()(tPARAMATER1 _paramater1, tPARAMATER2 _paramater2, tPARAMATER3 _paramater3, tPARAMATER4 _paramater4, tPARAMATER5 _paramater5, tPARAMATER6 _paramater6) {
			tconnections::iterator i   = myConnections.begin();
			thOVCheck valid(myOVStack);
			bool done = false;

			if (i != myConnections.end()) {
				tconnections::iterator end = --myConnections.end();
				while (!done) {
					if (i == end)
						done = true;

					if (((*i).isValid()) && ((*i).nSlRefs() != 0)) {
						(*(*i).getSlot())(_paramater1, _paramater2, _paramater3, _paramater4, _paramater5, _paramater6);
						if (!valid)
							break;

						if (((*i).isValid()) && ((*i).nSlRefs() != 0))
							++i;
						else
							i = myConnections.erase(i);
					}
					else {
						i = myConnections.erase(i);
					}
				}
			}
		}

		thSlot_6<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5, xPARAMATER6> connect(const thSlot_6<void, xPARAMATER1, xPARAMATER2, xPARAMATER3, xPARAMATER4, xPARAMATER5, xPARAMATER6> & _slot) {
			myConnections.push_back(_slot);
			return _slot;
		}
		void disconnect(const thSlot & _slot) {
			tconnections::iterator i = myConnections.begin();
			for (;i != myConnections.end(); ++i) {
				if (*i == _slot) {
					myConnections.erase(i);
					break;
				}
			}
			thASSERT(i != myConnections.end());
		}
	};


